PLaSK library

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | Protected Member Functions | Protected Attributes | List of all members
plask::optical::modal::RootDigger Struct Referenceabstract

`#include <solvers/optical/modal/rootdigger.hpp>`

Inheritance diagram for plask::optical::modal::RootDigger:
[legend]
Collaboration diagram for plask::optical::modal::RootDigger:
[legend]

## Classes
struct | Params

## Public Types
enum | Method { ROOT_MULLER , ROOT_BROYDEN , ROOT_BRENT }
| Root finding method. More...
typedef std::function< dcomplex(dcomplex)> | function_type

## Public Member Functions
| RootDigger (ModalBase &solver, const function_type &val_fun, const Params &pars, const char *name)
virtual | ~RootDigger ()
virtual dcomplex | find (dcomplex start)=0
| Search for a single zero starting from the given point.

## Public Attributes
Params | params

## Protected Member Functions
template<typename... Args>
void | writelog (LogLevel level, const std::string &msg, Args &&... args) const
dcomplex | valFunction (dcomplex x) const

## Protected Attributes
ModalBase & | solver
function_type | val_function
DataLog< dcomplex, dcomplex > | log_value

## Detailed Description

Definition at line 24 of file rootdigger.hpp.

## Member Typedef Documentation

## ◆ function_type

typedef std::function<dcomplex(dcomplex)> plask::optical::modal::RootDigger::function_type

Definition at line 26 of file rootdigger.hpp.

## Member Enumeration Documentation

## ◆ Method

enum plask::optical::modal::RootDigger::Method

Root finding method.

Enumerator
ROOT_MULLER |
ROOT_BROYDEN |
ROOT_BRENT |

Definition at line 29 of file rootdigger.hpp.

## Constructor & Destructor Documentation

## ◆ RootDigger()

plask::optical::modal::RootDigger::RootDigger | ( | ModalBase & | solver,
|  | const function_type & | val_fun,
|  | const Params & | pars,
|  | const char * | name
| ) |  |

Definition at line 19 of file rootdigger.cpp.

## ◆ ~RootDigger()

virtual plask::optical::modal::RootDigger::~RootDigger | ( |  | ) |
| inline virtual

Definition at line 90 of file rootdigger.hpp.

## Member Function Documentation

## ◆ find()

virtual dcomplex plask::optical::modal::RootDigger::find | ( | dcomplex | start | ) |
| pure virtual

Search for a single zero starting from the given point.

Parameters

  start | initial point to start search from

Returns
  found solution

Implemented in plask::optical::modal::RootBrent, plask::optical::modal::RootBroyden, and plask::optical::modal::RootMuller.

## ◆ valFunction()

dcomplex plask::optical::modal::RootDigger::valFunction | ( | dcomplex | x | ) | const
| inline protected

Definition at line 73 of file rootdigger.hpp.

## ◆ writelog()

template<typename... Args>

void plask::optical::modal::RootDigger::writelog | ( | LogLevel | level,
|  | const std::string & | msg,
|  | Args &&... | args
| ) |  | const
| protected

Definition at line 23 of file rootdigger-impl.hpp.

## Member Data Documentation

## ◆ log_value

DataLog<dcomplex,dcomplex> plask::optical::modal::RootDigger::log_value
| protected

Definition at line 71 of file rootdigger.hpp.

## ◆ params

Params plask::optical::modal::RootDigger::params

Definition at line 85 of file rootdigger.hpp.

## ◆ solver

ModalBase& plask::optical::modal::RootDigger::solver
| protected

Definition at line 65 of file rootdigger.hpp.

## ◆ val_function

function_type plask::optical::modal::RootDigger::val_function
| protected

Definition at line 68 of file rootdigger.hpp.

The documentation for this struct was generated from the following files:

- solvers/optical/modal/rootdigger.hpp
- solvers/optical/modal/rootdigger-impl.hpp
- solvers/optical/modal/rootdigger.cpp